// Primalitatea unui numar natural
#include <iostream>
#include <cmath>
using namespace std;

bool EstePrim(int n); // prototipul functiei

int main()
{
	int x;
	cin >> x;
	
	if (EstePrim(x))
		cout << x << " este prim";
	else
		cout << x << " nu este prim";
	
}

/* n = 31
 * 
 * 3 5  6 7 8 ...30
 * d
 * 
 * d * p = n
 * 
 * cautam numai divizori impari
 * 3 5 7 9 11.. sqrt(n)
 */ 


bool EstePrim(int n) 
{
	// cazuri particulare
	if (n < 2)         // daca n e 0 sau 1, atunci nu este prim
		return false;
	
	if (n == 2)        // 2 este nr prim
		return true;
	
	if (n % 2 == 0)    // daca n este par (dar nu 2)
		return false;  // atunci nu este prim
	
	for (int d = 3; d <= sqrt(n); d += 2)  // O(sqrt(n)) = complexitate liniara
		if (n % d == 0)   // daca am gasit un divizor
			return false; // atunci n nu este prim
	
	return true; // daca s- a ajuns aici, atunci n este prim
}
